Recently your team noticed that the computer you use to practice for programming contests is not
good enough anymore. Therefore, you decide to buy a new computer.
To make the ideal computer for your needs, you decide to buy separate components and assemble
the computer yourself. You need to buy exactly one of each type of component.
The problem is which components to buy. As you all know, the quality of a computer is equal to
the quality of its weakest component. Therefore, you want to maximize the quality of the component
with the lowest quality, while not exceeding your budg

Input

On the first line one positive number: the number of testcases, at most 100. After that per testcase:

  • One line with two integers: 1 ≤ n ≤ 1000, the number of available components and 1 ≤ b ≤
1000000000, your budget.
  • n lines in the following format: ‘type name price quality’, where type is a string with the type
of the component, name is a string with the unique name of the component, price is an integer
(0 ≤ price ≤ 1000000) which represents the price of the component and quality is an integer
(0 ≤ quality ≤ 1000000000) which represents the quality of the component (higher is better). The
strings contain only letters, digits and underscores and have a maximal length of 20 characters.
It will always possible to construct a computer with your budget.
Output
Per testcase:
  • One line with one integer: the maximal possible quality.


Sample Input
1
18 800
processor 3500_MHz 66 5
processor 4200_MHz 103 7
processor 5000_MHz 156 9
processor 6000_MHz 219 12
memory 1_GB 35 3
memory 2_GB 88 6
memory 4_GB 170 12
mainbord all_onboard 52 10
harddisk 250_GB 54 10
harddisk 500_FB 99 12
casing midi 36 10
monitor 17_inch 157 5
monitor 19_inch 175 7
monitor 20_inch 210 9
monitor 22_inch 293 12
mouse cordless_optical 18 12
mouse microsoft 30 9
keyboard office 4 10


Sample Output
9

 

求出给出的配件中,在不超过给出的总价格b的情况下,品质最好的一组。

贪心,由于数据过大,使用二分搜索贪心。

 //Asimple
#include <bits/stdc++.h>
#define swap(a,b,t) t = a, a = b, b = t
#define CLS(a, v) memset(a, v, sizeof(a))
#define debug(a)  cout << #a << " = "  << a <<endl
using namespace std;
typedef long long ll;
const int maxn = 1000+5;
ll n, m, res, ans, len, T, k, num, sum, l;

//二分搜索
map<string, int> mp;
int cnt;
int add(string s){
    if( !mp.count(s) ) mp[s] = cnt++;
    return mp[s];
}

struct node{
    ll cost;
    ll pz;
};
vector<node> comp[maxn];

bool ok(int q){
    sum = 0;
    for(int i=0; i<cnt; i++) {
        ll cs = num+1, m = comp[i].size();
        for(int j=0; j<m; j++) {
            if( comp[i][j].pz>=q) cs = min(cs, comp[i][j].cost);
        }
        if( cs == num+1 ) return false;
        sum += cs;
        if( sum>num ) return false;
    }
    return true;
}

void input() {
    ios_base::sync_with_stdio(false);
    cin >> T;
    while( T-- ) {
        cin >> n >> num;
        cnt = 0;
        for(int i=0; i<n; i++) comp[i].clear();
        mp.clear();
        ll Max = 0;
        for(int i=0; i<n; i++) {
            string s1, s2;
            ll p, q;
            cin >> s1 >> s2 >> p >> q;
            Max = max(Max, q);
            comp[add(s1)].push_back((node){p, q});
        }
        int L = 0, R = Max;
        while( L < R ) {
            int mid = L+(R-L+1)/2;
            if( ok(mid) ) L = mid;
            else R = mid-1;
        }
        cout << L << endl;
    }
}

int main(){
    input();
    return 0;
}